diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaico.cpp ./win32/dependencies/cximage/ximaico.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaico.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximaico.cpp	2006-08-24 07:16:02 +0900
@@ -0,0 +1,299 @@
+/*
+ * File:	ximaico.cpp
+ * Purpose:	Platform Independent ICON Image Class Loader and Writer (MS version)
+ * 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximaico.h"
+
+#if CXIMAGE_SUPPORT_ICO
+
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageICO::Decode(CxFile *hFile)
+{
+	if (hFile==NULL) return false;
+
+	DWORD off = hFile->Tell(); //<yuandi>
+	int	page=info.nFrame;	//internal icon structure indexes
+
+	// read the first part of the header
+	ICONHEADER icon_header;
+	hFile->Read(&icon_header,sizeof(ICONHEADER),1);
+	// check if it's an icon or a cursor
+	if ((icon_header.idReserved == 0) && ((icon_header.idType == 1)||(icon_header.idType == 2))) {
+
+		info.nNumFrames = icon_header.idCount;
+
+		// load the icon descriptions
+		ICONDIRENTRY *icon_list = (ICONDIRENTRY *)malloc(icon_header.idCount * sizeof(ICONDIRENTRY));
+		int c;
+		for (c = 0; c < icon_header.idCount; c++)
+			hFile->Read(icon_list + c, sizeof(ICONDIRENTRY), 1);
+		
+		if ((page>=0)&&(page<icon_header.idCount)){
+
+			// get the bit count for the colors in the icon <CoreyRLucier>
+			BITMAPINFOHEADER bih;
+			hFile->Seek(off + icon_list[page].dwImageOffset, SEEK_SET);
+			hFile->Read(&bih,sizeof(BITMAPINFOHEADER),1);
+			c = bih.biBitCount;
+
+			// allocate memory for one icon
+			Create(icon_list[page].bWidth,icon_list[page].bHeight, c, CXIMAGE_FORMAT_ICO);	//image creation
+
+			// read the palette
+			RGBQUAD pal[256];
+			hFile->Read(pal,head.biClrUsed*sizeof(RGBQUAD), 1);
+			SetPalette(pal,head.biClrUsed);	//palette assign
+
+			//read the icon
+			if (c<=24){
+				hFile->Read(info.pImage, head.biSizeImage, 1);
+			} else { // 32 bit icon
+				BYTE* dst = info.pImage;
+				BYTE* buf=(BYTE*)malloc(4*head.biHeight*head.biWidth);
+				BYTE* src = buf;
+				hFile->Read(buf, 4*head.biHeight*head.biWidth, 1);
+#if CXIMAGE_SUPPORT_ALPHA
+				if (!AlphaIsValid()) AlphaCreate();
+#endif //CXIMAGE_SUPPORT_ALPHA
+				for (long y = 0; y < head.biHeight; y++) {
+					for(long x=0;x<head.biWidth;x++){
+						*dst++=src[0];
+						*dst++=src[1];
+						*dst++=src[2];
+#if CXIMAGE_SUPPORT_ALPHA
+						AlphaSet(x,y,src[3]);
+#endif //CXIMAGE_SUPPORT_ALPHA
+						src+=4;
+					}
+				}
+				free(buf);
+			}
+			// apply the AND and XOR masks
+			int maskwdt = ((head.biWidth+31) / 32) * 4;	//line width of AND mask (always 1 Bpp)
+			int masksize = head.biHeight * maskwdt;				//size of mask
+			BYTE *mask = (BYTE *)malloc(masksize);
+			if (hFile->Read(mask, masksize, 1)){
+
+				bool bGoodMask=false;
+				for (int im=0;im<masksize;im++){
+					if (mask[im]!=255){
+						bGoodMask=true;
+						break;
+					}
+				}
+
+				if (bGoodMask){
+#if CXIMAGE_SUPPORT_ALPHA
+					bool bNeedAlpha = false;
+					if (!AlphaIsValid()){
+						AlphaCreate();
+					} else { 
+						bNeedAlpha=true; //32bit icon
+					}
+					for (int y = 0; y < head.biHeight; y++) {
+						for (int x = 0; x < head.biWidth; x++) {
+							if (((mask[y*maskwdt+(x>>3)]>>(7-x%8))&0x01)){
+								AlphaSet(x,y,0);
+								bNeedAlpha=true;
+							}
+						}
+					}
+					if (!bNeedAlpha) AlphaDelete();
+#endif //CXIMAGE_SUPPORT_ALPHA
+
+					if (c==24){ //check if there is only one transparent color
+						RGBQUAD cc,ct;
+						long* pcc = (long*)&cc;
+						long* pct = (long*)&ct;
+						int nTransColors=0;
+						for (int y = 0; y < head.biHeight; y++){
+							for (int x = 0; x < head.biWidth; x++){
+								if (((mask[y*maskwdt+(x>>3)] >> (7-x%8)) & 0x01)){
+									cc = GetPixelColor(x,y,false);
+									if (nTransColors==0){
+										nTransColors++;
+										ct = cc;
+									} else {
+										if (*pct!=*pcc){
+											nTransColors++;
+										}
+									}
+								}
+							}
+						}
+						if (nTransColors==1){
+							SetTransColor(ct);
+							SetTransIndex(0);
+#if CXIMAGE_SUPPORT_ALPHA
+							AlphaDelete(); //because we have a unique transparent color in the image
+#endif //CXIMAGE_SUPPORT_ALPHA
+						}
+					}
+
+					// <vho> - Transparency support w/o Alpha support
+					if (c <= 8){ // only for icons with less than 256 colors (XP icons need alpha).
+						  
+						// find a color index, which is not used in the image
+						// it is almost sure to find one, bcs. nobody uses all possible colors for an icon
+
+						BYTE colorsUsed[256];
+						memset(colorsUsed, 0, sizeof(colorsUsed));
+
+						for (int y = 0; y < head.biHeight; y++){
+							for (int x = 0; x < head.biWidth; x++){
+								colorsUsed[GetPixelIndex(x,y)] = 1;
+							}
+						}
+
+						int iTransIdx = -1;
+						for (int x = 0; x < (int)head.biClrUsed; x++){
+							if (colorsUsed[x] == 0){
+								iTransIdx = x; // this one is not in use. we may use it as transparent color
+								break;
+							}
+						}
+
+						// Go thru image and set unused color as transparent index if needed
+						if (iTransIdx >= 0){
+							bool bNeedTrans = false;
+							for (int y = 0; y < head.biHeight; y++){
+								for (int x = 0; x < head.biWidth; x++){
+									// AND mask (Each Byte represents 8 Pixels)
+									if (((mask[y*maskwdt+(x>>3)] >> (7-x%8)) & 0x01)){
+										// AND mask is set (!=0). This is a transparent part
+										SetPixelIndex(x, y, iTransIdx);
+										bNeedTrans = true;
+									}
+								}
+							}
+							// set transparent index if needed
+							if (bNeedTrans)	SetTransIndex(iTransIdx);
+#if CXIMAGE_SUPPORT_ALPHA
+							AlphaDelete(); //because we have a transparent color in the palette
+#endif //CXIMAGE_SUPPORT_ALPHA
+						}
+					}
+				} else {
+					SetTransIndex(0); //empty mask, set black as transparent color
+					Negative();
+				}
+			} 
+			free(mask);
+
+			free(icon_list);
+			// icon has been loaded successfully!
+			return true;
+		}
+		free(icon_list);
+	}
+	return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageICO::Encode(CxFile * hFile)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	//check format limits
+	if ((head.biWidth>255)||(head.biHeight>255)){
+		strcpy(info.szLastError,"Can't save this image as icon");
+		return false;
+	}
+
+	//prepare the palette struct
+	RGBQUAD* pal=GetPalette();
+	if (head.biBitCount<=8 && pal==NULL) return false;
+
+	int maskwdt=((head.biWidth+31)/32)*4; //mask line width
+	int masksize=head.biHeight * maskwdt; //size of mask
+	int bitcount=head.biBitCount;
+	int imagesize=head.biSizeImage;
+#if CXIMAGE_SUPPORT_ALPHA
+	if (AlphaIsValid() && head.biClrUsed==0){
+		bitcount=32;
+		imagesize=4*head.biHeight*head.biWidth;
+	}
+#endif
+
+	//fill the icon headers
+	ICONHEADER icon_header={0,1,1};
+	ICONDIRENTRY icon_list={(BYTE)head.biWidth,(BYTE)head.biHeight,(BYTE)head.biClrUsed ,0,0,(WORD)bitcount,
+							sizeof(BITMAPINFOHEADER)+head.biClrUsed*sizeof(RGBQUAD)+
+							imagesize+masksize,
+							sizeof(ICONHEADER)+sizeof(ICONDIRENTRY)};
+	BITMAPINFOHEADER bi={sizeof(BITMAPINFOHEADER),head.biWidth,2*head.biHeight,1,(WORD)bitcount,
+						0,imagesize,0,0,0,0};
+
+	hFile->Write(&icon_header,sizeof(ICONHEADER),1);			//write the headers
+	hFile->Write(&icon_list,sizeof(ICONDIRENTRY),1);
+	hFile->Write(&bi,sizeof(BITMAPINFOHEADER),1);
+	if (pal) hFile->Write(pal,head.biClrUsed*sizeof(RGBQUAD),1); //write palette
+
+#if CXIMAGE_SUPPORT_ALPHA
+	if (AlphaIsValid() && head.biClrUsed==0){
+		BYTE* src = info.pImage;
+		BYTE* buf=(BYTE*)malloc(imagesize);
+		BYTE* dst = buf;
+		for (long y = 0; y < head.biHeight; y++) {
+			for(long x=0;x<head.biWidth;x++){
+				*dst++=*src++;
+				*dst++=*src++;
+				*dst++=*src++;
+				*dst++=AlphaGet(x,y);
+			}
+		}
+		hFile->Write(buf,imagesize, 1);
+		free(buf);
+	} else {
+		hFile->Write(info.pImage,imagesize,1);	//write image
+	}
+#else
+	hFile->Write(info.pImage,imagesize,1);	//write image
+#endif
+
+	//save transparency mask
+	BYTE* mask=(BYTE*)calloc(masksize,1);	//create empty AND/XOR masks
+	if (!mask) return false;
+
+	//prepare the variables to build the mask
+	BYTE* iDst;
+	int pos,i;
+	RGBQUAD c={0,0,0,0};
+	RGBQUAD ct = GetTransColor();
+	long* pc = (long*)&c;
+	long* pct= (long*)&ct;
+	bool bTransparent = info.nBkgndIndex != -1;
+#if CXIMAGE_SUPPORT_ALPHA
+	bool bAlphaPaletteIsValid = AlphaPaletteIsValid();
+	bool bAlphaIsValid = AlphaIsValid();
+#endif
+	//build the mask
+	for (int y = 0; y < head.biHeight; y++) {
+		for (int x = 0; x < head.biWidth; x++) {
+			i=0;
+#if CXIMAGE_SUPPORT_ALPHA
+			if (bAlphaIsValid && AlphaGet(x,y)==0) i=1;
+			if (bAlphaPaletteIsValid && GetPixelColor(x,y).rgbReserved==0) i=1;
+#endif
+			c=GetPixelColor(x,y,false);
+			if (bTransparent && *pc==*pct) i=1;
+			iDst = mask + y*maskwdt + (x>>3);
+			pos = 7-x%8;
+			*iDst &= ~(0x01<<pos);
+			*iDst |= ((i & 0x01)<<pos);
+		}
+	}
+	//write AND/XOR masks
+	hFile->Write(mask,masksize,1);
+	free(mask);
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_ICO
+
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaico.h ./win32/dependencies/cximage/ximaico.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximaico.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximaico.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,52 @@
+/*
+ * File:	ximaico.h
+ * Purpose:	ICON Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageICO (c) 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ * ==========================================================
+ */
+#if !defined(__ximaICO_h)
+#define __ximaICO_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_ICO
+
+class CxImageICO: public CxImage
+{
+typedef struct tagIconDirectoryEntry {
+    BYTE  bWidth;
+    BYTE  bHeight;
+    BYTE  bColorCount;
+    BYTE  bReserved;
+    WORD  wPlanes;
+    WORD  wBitCount;
+    DWORD dwBytesInRes;
+    DWORD dwImageOffset;
+} ICONDIRENTRY;
+
+typedef struct tagIconDir {
+    WORD          idReserved;
+    WORD          idType;
+    WORD          idCount;
+} ICONHEADER;
+
+public:
+	CxImageICO(): CxImage(CXIMAGE_FORMAT_ICO) {}
+
+//	bool Load(const char * imageFileName){ return CxImage::Load(imageFileName,CXIMAGE_FORMAT_ICO);}
+//	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,CXIMAGE_FORMAT_ICO);}
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+};
+
+#endif
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximainfo.cpp ./win32/dependencies/cximage/ximainfo.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximainfo.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximainfo.cpp	2006-08-24 07:16:02 +0900
@@ -0,0 +1,388 @@
+// ximainfo.cpp : main attributes
+/* 03/10/2004 v1.00 - Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximage.h"
+
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return the color used for transparency, and/or for background color
+ */
+RGBQUAD	CxImage::GetTransColor()
+{
+	if (head.biBitCount<24 && info.nBkgndIndex != -1) return GetPaletteColor((BYTE)info.nBkgndIndex);
+	return info.nBkgndColor;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Gets the index used for transparency. Returns -1 for no transparancy.
+ */
+long CxImage::GetTransIndex() const
+{
+	return info.nBkgndIndex;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets the index used for transparency with 1, 4 and 8 bpp images. Set to -1 to remove the effect.
+ */
+void CxImage::SetTransIndex(long idx)
+{
+	info.nBkgndIndex = idx;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets the color used for transparency with 24 bpp images.
+ * You must call SetTransIndex(0) to enable the effect, SetTransIndex(-1) to disable it.
+ */
+void CxImage::SetTransColor(RGBQUAD rgb)
+{
+	rgb.rgbReserved=0;
+	info.nBkgndColor = rgb;
+}
+////////////////////////////////////////////////////////////////////////////////
+bool CxImage::IsTransparent() const
+{
+	return info.nBkgndIndex>=0; // <vho>
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Returns true if the image has 256 colors or less.
+ */
+bool CxImage::IsIndexed() const
+{
+	return head.biClrUsed!=0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return 1 = indexed, 2 = RGB, 4 = RGBA
+ */
+BYTE CxImage::GetColorType()
+{
+	BYTE b = (BYTE)((head.biBitCount>8) ? 2 /*COLORTYPE_COLOR*/ : 1 /*COLORTYPE_PALETTE*/);
+#if CXIMAGE_SUPPORT_ALPHA
+	if (AlphaIsValid()) b = 4 /*COLORTYPE_ALPHA*/;
+#endif //CXIMAGE_SUPPORT_ALPHA
+	return b;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return Resolution for TIFF, JPEG, PNG and BMP formats.
+ */
+long CxImage::GetXDPI() const
+{
+	return info.xDPI;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return Resolution for TIFF, JPEG, PNG and BMP formats.
+ */
+long CxImage::GetYDPI() const
+{
+	return info.yDPI;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Set resolution for TIFF, JPEG, PNG and BMP formats.
+ */
+void CxImage::SetXDPI(long dpi)
+{
+	if (dpi<=0) dpi=96;
+	info.xDPI = dpi;
+	head.biXPelsPerMeter = (long) floor(dpi * 10000.0 / 254.0 + 0.5);
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Set resolution for TIFF, JPEG, PNG and BMP formats.
+ */
+void CxImage::SetYDPI(long dpi)
+{
+	if (dpi<=0) dpi=96;
+	info.yDPI = dpi;
+	head.biYPelsPerMeter = (long) floor(dpi * 10000.0 / 254.0 + 0.5);
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \sa SetFlags
+ */
+DWORD CxImage::GetFlags() const
+{
+	return info.dwFlags;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Image flags, for future use
+ * \param flags
+ *  - 0x??00000 = reserved for 16 bit, CMYK, multilayer
+ *  - 0x00??0000 = blend modes
+ *  - 0x0000???? = layer id or user flags
+ *
+ * \param bLockReservedFlags protects the "reserved" and "blend modes" flags 
+ */
+void CxImage::SetFlags(DWORD flags, bool bLockReservedFlags)
+{
+	if (bLockReservedFlags) info.dwFlags = flags & 0x0000ffff;
+	else info.dwFlags = flags;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \sa SetCodecOption
+ */
+DWORD CxImage::GetCodecOption(DWORD imagetype)
+{
+	if (imagetype<CMAX_IMAGE_FORMATS){
+		if (imagetype==0){
+			imagetype = GetType();
+		}
+		return info.dwCodecOpt[imagetype];
+	}
+	return 0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Encode option for GIF, TIF and JPG.
+ * - GIF : 0 = LZW (default), 1 = none, 2 = RLE.
+ * - TIF : 0 = automatic (default), or a valid compression code as defined in "tiff.h" (COMPRESSION_NONE = 1, COMPRESSION_CCITTRLE = 2, ...)
+ * - JPG : valid values stored in enum CODEC_OPTION ( ENCODE_BASELINE = 0x01, ENCODE_PROGRESSIVE = 0x10, ...)
+ *
+ * \return true if everything is ok
+ */
+bool CxImage::SetCodecOption(DWORD opt, DWORD imagetype)
+{
+	if (imagetype<CMAX_IMAGE_FORMATS){
+		if (imagetype==0){
+			imagetype = GetType();
+		}
+		info.dwCodecOpt[imagetype] = opt;
+		return true;
+	}
+	return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return internal hDib object..
+ */
+void* CxImage::GetDIB() const
+{
+	return pDib;
+}
+////////////////////////////////////////////////////////////////////////////////
+DWORD CxImage::GetHeight() const
+{
+	return head.biHeight;
+}
+////////////////////////////////////////////////////////////////////////////////
+DWORD CxImage::GetWidth() const
+{
+	return head.biWidth;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return DWORD aligned width of the image.
+ */
+DWORD CxImage::GetEffWidth() const
+{
+	return info.dwEffWidth;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return 2, 16, 256; 0 for RGB images.
+ */
+DWORD CxImage::GetNumColors() const
+{
+	return head.biClrUsed;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return: 1, 4, 8, 24.
+ */
+WORD CxImage::GetBpp() const
+{
+	return head.biBitCount;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return original image format
+ * \sa ENUM_CXIMAGE_FORMATS.
+ */
+DWORD CxImage::GetType() const
+{
+	return info.dwType;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return current frame delay in milliseconds. Only for GIF and MNG formats.
+ */
+DWORD CxImage::GetFrameDelay() const
+{
+	return info.dwFrameDelay;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets current frame delay. Only for GIF format.
+ * \param d = delay in milliseconds
+ */
+void CxImage::SetFrameDelay(DWORD d)
+{
+	info.dwFrameDelay=d;
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImage::GetOffset(long *x,long *y)
+{
+	*x=info.xOffset;
+	*y=info.yOffset;
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImage::SetOffset(long x,long y)
+{
+	info.xOffset=x;
+	info.yOffset=y;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \sa SetJpegQuality
+ */
+BYTE CxImage::GetJpegQuality() const
+{
+	return info.nQuality;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * quality level for JPEG and JPEG2000
+ * \param q: can be from 0 to 100
+ */
+void CxImage::SetJpegQuality(BYTE q){
+	info.nQuality = q;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \sa SetJpegScale
+ */
+BYTE CxImage::GetJpegScale() const
+{
+	return info.nJpegScale;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * scaling down during JPEG decoding valid numbers are 1, 2, 4, 8
+ * \author [ignacio]
+ */
+void CxImage::SetJpegScale(BYTE q){
+	info.nJpegScale = q;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Used to monitor the slow loops.
+ * \return value is from 0 to 100.
+ * \sa SetProgress
+ */
+long CxImage::GetProgress() const
+{
+	return info.nProgress;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return the escape code.
+ * \sa SetEscape
+ */
+long CxImage::GetEscape() const
+{
+	return info.nEscape;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Forces the value of the internal progress variable.
+ * \param p should be from 0 to 100.
+ * \sa GetProgress
+ */
+void CxImage::SetProgress(long p)
+{
+	info.nProgress = p;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Used to quit the slow loops or the codecs.
+ * - SetEscape(-1) before Decode forces the function to exit, right after  
+ *   the image width and height are available ( for bmp, jpg, gif, tif )
+ */
+void CxImage::SetEscape(long i)
+{
+	info.nEscape = i;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Checks if the image is correctly initializated.
+ */
+bool CxImage::IsValid() const
+{
+	return pDib!=0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * True if the image is enabled for painting.
+ */
+bool CxImage::IsEnabled() const
+{
+	return info.bEnabled;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Enables/disables the image.
+ */
+void CxImage::Enable(bool enable)
+{
+	info.bEnabled=enable;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * This function must be used after a Decode() / Load() call.
+ * Use the sequence SetFrame(-1); Load(...); GetNumFrames();
+ * to get the number of images without loading the first image.
+ * \return the number of images in the file.
+ */
+long CxImage::GetNumFrames() const
+{
+	return info.nNumFrames;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return the current selected image (zero-based index).
+ */
+long CxImage::GetFrame() const
+{
+	return info.nFrame;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Sets the image number that the next Decode() / Load() call will load
+ */
+void CxImage::SetFrame(long nFrame){
+	info.nFrame=nFrame;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Returns the last reported error.
+ */
+const char* CxImage::GetLastError()
+{
+	return info.szLastError;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * \return A.BBCCCDDDD
+ *  - A = main version
+ *  - BB = main revision
+ *  - CCC = minor revision (letter)
+ *  - DDDD = experimental revision
+ */
+const float CxImage::GetVersionNumber()
+{
+	return 5.99003f;
+}
+////////////////////////////////////////////////////////////////////////////////
+const TCHAR* CxImage::GetVersion()
+{
+	static const TCHAR CxImageVersion[] = _T("CxImage 5.99c");
+	return (CxImageVersion);
+}
+////////////////////////////////////////////////////////////////////////////////
